// SelectStartupDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SelectStartup.h"
#include "SelectStartupDlg.h"
#include "csub.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib, "shlwapi.lib")

/////////////////////////////////////////////////////////////////////////////
// CSelectStartupDlg _CAO

CSelectStartupDlg::CSelectStartupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectStartupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectStartupDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSelectStartupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectStartupDlg)
	DDX_Control(pDX, IDC_LIST_ENABLE, m_lEnable);
	DDX_Control(pDX, IDC_LIST_DISABLE, m_lDisable);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_bRemove);
	DDX_Control(pDX, IDC_BUTTON_ENABLE, m_bEnable);
	DDX_Control(pDX, IDC_BUTTON_DISABLE, m_bDisable);
	DDX_Control(pDX, IDOK, m_bOK);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelectStartupDlg, CDialog)
	//{{AFX_MSG_MAP(CSelectStartupDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_DISABLE, OnButtonDisable)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE, OnButtonEnable)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_LBN_SELCHANGE(IDC_LIST_ENABLE, OnSelchangeListEnable)
	ON_LBN_SELCHANGE(IDC_LIST_DISABLE, OnSelchangeListDisable)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_WM_DROPFILES()
	ON_MESSAGE(WM_CHANGE_STARTUP, OnChangeStartup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectStartupDlg bZ[W nh

BOOL CSelectStartupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	SetList();
	m_change_flag = false;

	m_check_flag = true;
	m_thread = AfxBeginThread(CheckStartup, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
	m_thread->m_bAutoDelete = FALSE;
	m_thread->ResumeThread();

	DragAcceptFiles(TRUE);

	CheckButton();

	return TRUE;
}

void CSelectStartupDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	} else {
		CDialog::OnPaint();
	}
}

HCURSOR CSelectStartupDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSelectStartupDlg::OnOK() 
{
	CString name;

	GetModuleFileName(NULL, name.GetBuffer(MAX_PATH), MAX_PATH);
	name.ReleaseBuffer();
	// g̃V[gJbgX^[gAbvtH_ɓo^
	if(CreateShortcut(name, m_startup_shortcut)) {
		//m_bRemove.EnableWindow(TRUE);
	}
	ForceDirectory(m_disable_dir);
	MoveStartupLinkFile();

	AfxMessageBox(GetString(IDS_CHANGE_END));

	m_change_flag = false;

	CheckButton();
}

void CSelectStartupDlg::MoveStartupLinkFile()
{
	int no;
	CString name;
	CString startup_file, disable_file;

	// V[gJbg̈ړ
	for(no = 0 ; no < m_lEnable.GetCount() ; no++) {
		m_lEnable.GetText(no, name);
		startup_file = m_startup_dir + _T("\\") + name + _T(".lnk");
		disable_file = m_disable_dir + _T("\\") + name + _T(".lnk");
		if(!PathFileExists(startup_file) && PathFileExists(disable_file)) {
			MoveFile(disable_file, startup_file);
		}
	}
	for(no = 0 ; no < m_lDisable.GetCount() ; no++) {
		m_lDisable.GetText(no, name);
		disable_file = m_disable_dir + _T("\\") + name + _T(".lnk");
		startup_file = m_startup_dir + _T("\\") + name + _T(".lnk");
		if(!PathFileExists(disable_file) && PathFileExists(startup_file)) {
			MoveFile(startup_file, disable_file);
		}
	}
}

void CSelectStartupDlg::OnButtonDisable() 
{
	int pos = m_lEnable.GetCount() - 1;
	while(pos >= 0) {
		if(m_lEnable.GetSel(pos)) {
			CString name;
			m_lEnable.GetText(pos, name);
			m_lEnable.DeleteString(pos);
			m_lDisable.AddString(name);
			m_change_flag = true;
		}
		pos--;
	}
	CheckButton();
}

void CSelectStartupDlg::OnButtonEnable() 
{
	int pos = m_lDisable.GetCount() - 1;
	while(pos >= 0) {
		if(m_lDisable.GetSel(pos)) {
			CString name;
			m_lDisable.GetText(pos, name);
			m_lDisable.DeleteString(pos);
			m_lEnable.AddString(name);
			m_change_flag = true;
		}
		pos--;
	}
	CheckButton();
}

void CSelectStartupDlg::OnButtonRemove() 
{
	int pos = m_lDisable.GetCount() - 1;
	while(pos >= 0) {
		CString name;
		m_lDisable.GetText(pos, name);
		m_lDisable.DeleteString(pos);
		m_lEnable.AddString(name);
		pos--;
	}
	MoveStartupLinkFile();
	RemoveDirectory(m_disable_dir);
	// g̃V[gJbg폜
	if(DeleteFile(m_startup_shortcut)) {
		//m_bRemove.EnableWindow(FALSE);
	}
	AfxMessageBox(GetString(IDS_REMOVE_END));

	m_change_flag = false;

	CheckButton();
}

void CSelectStartupDlg::SetList()
{
	m_startup_dir = GetStartupDirectory();
	SetFileList(m_startup_dir, &m_lEnable);
	m_startup_shortcut = m_startup_dir + _T("\\") + StartupShortcutName;

	m_disable_dir = GetAppDataDirectory() + DisableDirName;
	ForceDirectory(m_disable_dir);
	SetFileList(m_disable_dir, &m_lDisable);

	CheckButton();
}

void CSelectStartupDlg::SetFileList(CString path, CListBox *list)
{
	CFileFind ff;
	CString name;

	list->ResetContent();
	BOOL flag = ff.FindFile(path + _T("\\*.lnk"));
	while(flag) {
		flag = ff.FindNextFile();
		if(!ff.IsDots() && !ff.IsDirectory()) {
			name = ff.GetFileName();
			if(name == StartupShortcutName && list == &m_lEnable) {
				//m_bRemove.EnableWindow(TRUE);
			} else {
				list->AddString(ExtractName(name));
			}
		}
	}
	ff.Close();
}

void CSelectStartupDlg::CheckButton()
{
	m_bDisable.EnableWindow(m_lEnable.GetSelCount() > 0);
	m_bEnable.EnableWindow(m_lDisable.GetSelCount() > 0);
	if(!PathFileExists(m_startup_shortcut) || m_change_flag) {
		m_bOK.EnableWindow(TRUE);
	} else {
		m_bOK.EnableWindow(FALSE);
	}
	if(PathFileExists(m_startup_shortcut)) {
		m_bRemove.EnableWindow(TRUE);
	} else {
		m_bRemove.EnableWindow(FALSE);
	}
}

void CSelectStartupDlg::OnSelchangeListEnable() 
{
	CheckButton();
}

void CSelectStartupDlg::OnSelchangeListDisable() 
{
	CheckButton();
}

void CSelectStartupDlg::OnCancel() 
{
	if(m_change_flag) {
		// ύXΖ₢킹
		if(AfxMessageBox(GetString(IDS_QUERY_CHANGED_END), MB_YESNO) != IDYES) {
			return;
		}
	}
	CDialog::OnCancel();
}

void CSelectStartupDlg::OnButtonOpen() 
{
	// X^[gAbvtH_J
	ShellExecute(NULL, _T("open"), m_startup_dir, NULL, NULL, SW_SHOWNORMAL);
}

BOOL CSelectStartupDlg::AddStartup(CString name)
{
	BOOL result = FALSE;
	CString ext = PathFindExtension(name);

	if(!ext.CompareNoCase(_T(".lnk"))) {
		// V[gJbgȂ炻̂܂܃Rs[
		result = CopyFile(name, m_startup_dir + _T("\\") + ExtractFileName(name), FALSE);
	} else {
		// t@CȂV[gJbg쐬
		result = CreateShortcut(name, m_startup_dir + _T("\\") + ExtractName(ExtractFileName(name)) + _T(".lnk"), false);
	}
	if(result) {
		SetFileList(m_startup_dir, &m_lEnable);
	}
	CheckButton();

	return result;
}

void CSelectStartupDlg::OnButtonAdd()
{
	// X^[gAbvtH_ɒǉ
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, GetString(IDS_FILE_EXT), this);
	if(dlg.DoModal() == IDOK) {
		CString name = dlg.GetPathName();
		AddStartup(name);
	}
}

void CSelectStartupDlg::OnDropFiles(HDROP hDropInfo)
{
	int count;

	// hbOhbvŃt@CX^[gAbvɒǉ
	count = ::DragQueryFile(hDropInfo, 0xffffffff, NULL, 0);
	if(count > 0) {
		CString name;
		::DragQueryFile(hDropInfo, 0, name.GetBuffer(MAX_PATH), MAX_PATH);
		name.ReleaseBuffer();

		AddStartup(name);
	}
    ::DragFinish(hDropInfo);
}

UINT CSelectStartupDlg::CheckStartup(VOID *pParam)
{
	CSelectStartupDlg *ss = (CSelectStartupDlg *)pParam;

	// X^[gAbvtH_Ď
	DWORD filter = FILE_NOTIFY_CHANGE_FILE_NAME
		| FILE_NOTIFY_CHANGE_DIR_NAME
		| FILE_NOTIFY_CHANGE_ATTRIBUTES
		| FILE_NOTIFY_CHANGE_SIZE
		| FILE_NOTIFY_CHANGE_LAST_WRITE
		| FILE_NOTIFY_CHANGE_SECURITY;

	HANDLE h = FindFirstChangeNotification(ss->m_startup_dir, TRUE, filter);

	if(h != INVALID_HANDLE_VALUE) {
		do {
			if(WaitForSingleObject(h, 100) != WAIT_TIMEOUT) {
				// X^[gAbvtH_ɕω΃bZ[WM
				ss->PostMessage(WM_CHANGE_STARTUP);
			}
		} while(FindNextChangeNotification(h) && ss->m_check_flag);

		FindCloseChangeNotification(h);
	}
	return 0;
}

LRESULT CSelectStartupDlg::OnChangeStartup(WPARAM wParam, LPARAM lParam)
{
	// X^[gAbvtH_ɕω̂ŕ\XV
	SetFileList(m_startup_dir, &m_lEnable);

	CheckButton();
	return 0;
}


BOOL CSelectStartupDlg::DestroyWindow() 
{
	// X^[gAbvtH_ĎXbhI
	m_check_flag = false;
	if(m_thread != NULL) {
		WaitForSingleObject(m_thread->m_hThread, INFINITE);
		delete m_thread;
	}

	return CDialog::DestroyWindow();
}
